#ifndef _ENVVARS_

#define _ENVVARS_
#include <stdlib.h>

const enum ENVIRONMENT_VARIABLES
		{ zero,
		_SERVER_SOFTWARE,     _SERVER_NAME,       _GATEWAY_INTERFACE,
		_SERVER_PROTOCOL,     _SERVER_PORT,       _REQUEST_METHOD,
		_PATH_INFO,           _PATH_TRANSLATED,   _SCRIPT_NAME,
		_QUERY_STRING,        _REMOTE_HOST,       _REMOTE_ADDR,
		_REMOTE_IDENT,        _CONTENT_TYPE,      _CONTENT_LENGTH,
		_HTTP_ACCEPT,         _HTTP_USER_AGENT
  };
class EnvVars
{
  public:
	EnvVars();
	void EnvVars::display ()const ;
	char const *env_var(int) const ; // get environment vars using enum constant
	enum { _METHOD_UNKNOWN, _GET, _POST };
	int  cgi_method () { return method; }
	int const content_length;
	
  private:

	char const *server_software;
	char const *server_name;
	char const *gateway_interface;
	char const *server_protocol;
	char const *server_port;
	char const *request_method;
	char const *path_info;
	char const *path_translated;
	char const *script_name;
	char const *query_string;
	char const *remote_host;
	char const *remote_addr;
	char const *remote_ident;
	char const *content_type;
	char const *http_accept;
	char const *http_user_agent;
	char const *contentlength;
	int  method;
  //	static int FirstInstance;

	int contentlen ();

 } ;

 inline int EnvVars::contentlen ()
 {
  contentlength = getenv("CONTENT_LENGTH");
  if (contentlength) return atoi (contentlength);  return (0);
 }

#endif
