#ifndef _FIELDS_
#define _FIELDS_

#include <stdio.h>
#include <string.h>
#include <iostream.h>
#include "environ.h"

// helper functions
void unescape_url(char *url);
void plustospace(char *str);
char x2c(char *what);


typedef struct field_pairs {
  char *name; 
  char *value;
  int  retrieved;//set when value retrieved in getvalue: for multiples of NAME
  struct field_pairs *next;
} FIELDPAIRS;

class Fields
{
 public:
	 Fields(EnvVars&);
	 Fields(Fields &other);
    Fields &Fields::operator=(Fields &other);
	 ~Fields();
	 void display() const;
	 char *getvalue(char *) const;
	 void disableRetrieveFlag() { RetrieveFlagValue = 0; }
	 void enableRetrieveFlag () { RetrieveFlagValue = 1; }
	 void  reset();   // resets all retrieved flags to zero, for subsequent
						  //  calls to getvalue()
	 void reset(char *name);  // resets retrieved flags to zero for
									  // particular NAME

 private:
	 char *fieldstring;
	 FIELDPAIRS *fieldptrs;
	 static Fields *FirstInstance;
	 static int RetrieveFlagValue;
    static char *FieldStrBuf;
    void convert();
	 void setfields();

};


#endif
