#ifndef _HTML_CLASS_
#define _HTML_CLASS_
#include <iostream.h>

enum tags {
	_H1, _H2, _H3, _H4, _H5, _H6,
	_B, _I, _P, _BR };

extern char *tag[];
class HTML
{
  public:
	 HTML(const char *content_type);
	 HTML() { };
	 void text_out(int tag, char *text);
	 void otag(int tnum) const;   // open tag < >
	 void ctag(int tnum) const;   // close tag </ >
	 void otag(const char *) const;   // open tag < >
	 void ctag(const char *) const;   // close tag </ >
	 void header(const char *) const;  // open HTML / HEAD / TITLE tags
	 void obody(const char *format = "") const; //open body: <Body [format] >
	 void cbody() const;    //  </BODY>
	 void cHTML() const;     // </HTML>
	 void footer() const;   // close BODY and HTML tags

  private:
	 static int FirstInstance;


};


inline void HTML::otag(int tnum) const
{
  cout << '<' << tag[tnum] << '>';
}


inline void HTML::ctag(int tnum) const
{
 cout << "</" << tag[tnum] << '>';
}


inline void HTML::otag(const char *tag) const
{
  cout << '<' << tag << '>';
}


inline void HTML::ctag(const char *tag) const
{
 cout << "</" << tag << '>';
}

inline void HTML::header( const char *title) const
{
 cout << "<HTML><HEAD><TITLE>" << title << "</TITLE></HEAD>\n";

}

inline void HTML::obody(const char *format) const
{
 cout << "\n<BODY";
 if(*format) 	{
	 cout << ' ' << format;
	}

 cout << ">\n";
}
inline void HTML::footer() const
{
 cout << "\n\n";  cbody();  cHTML();
}

inline void HTML::cbody() const
{
  cout << "</BODY>\n";
}

inline void HTML::cHTML() const
{
  cout << "</HTML>\n";
}



 // TABLE CLASS
class TABLE  : public HTML
{
  public:
	 TABLE ();
	 TABLE (const char *formatstr);
	 ~TABLE ();
	 void format_row(char *format) { row_format = format; }
	 void row_out(int cols,...);
	 void ctable() { ctag("TABLE"); tableclosed = 1; }
  private:
	 int tcols;
	 char **tdata;
	 char *row_format;
	 void _row_out();
	 int tableclosed;

} ;


inline TABLE::TABLE ()
{
	 cout << '\n';
	 otag("TABLE");
	 row_format = 0;
	 tableclosed = 0;

}

inline TABLE::TABLE (const char *formatstr)
{
	 cout << "\n<TABLE ";
	 cout  << formatstr;
	 cout  << " >";
	 row_format = 0;
	 tableclosed = 0;
}

inline TABLE::~TABLE ()
{
	if (!tableclosed) ctag("TABLE");
}


 // LIST CLASS

enum LTYPE_ENUM { _OL_, _UL_, _DL_ };
extern char *LTypes[];
extern char *LMarkers[];
class OL {
 public:
	 char *LType, *LMarker;
	 OL() { LType = LTypes[_OL_]; LMarker = LMarkers[_OL_];}
};

class UL {
 public:
	 char *LType, *LMarker;
	 UL() { LType = LTypes[_UL_];LMarker = LMarkers[_UL_]; }
};

class DD {
 public:
	 char *LType, *LMarker;
	 DD() { LType = LTypes[_DL_];LMarker = LMarkers[_DL_]; }
};

template <class type>
class LIST  : public HTML
{
  public:
	 type ListType;
	 LIST (){ cout <<  "\n<" << ListType.LType << '>';  listclosed = 0;}
	~LIST (){
		  if (!listclosed) {
			 cout <<  "\n</" << ListType.LType << '>';
			 }
		  }
	 void item_out(char *str) const { cout << '\n';
		  otag(ListType.LMarker); cout << str; };
	 void clist(){ cout <<  "\n</" << ListType.LType << '>'; listclosed = 1;}
  private:
	  int listclosed;
} ;

class DLIST : public LIST <DD>
{
	public:
	 void DT (char *term = '\0')  { cout << '\n'; otag("DT"); cout << term; }

} ;

#define OLIST LIST <OL>
#define ULIST LIST <UL>

#endif
