#include "html.h"
#include <ctype.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>


int __strnicmp(const char *str1, const char *str2, size_t len)
{
  int i;
  char c1, c2;

	for(i=0; i < (int)len; i++)
	 {
		 c1 = (char)toupper(str1[i]);
		 c2 = (char)toupper(str2[i]);
		 if (c1 != c2) return(1);

	 }

		 return(0);
}



 // make_path will create a directory address or a URL from
 // the parameters passed to it.  It recognizes a port address by
 // the preceding semi-colon, as in :80.  This means that the port
 //address has to be constructed before being sent to make_path();
 // see the example in myCGI::processenv() in the file mycgi.cpp

char *make_path(int parms, ...)
{

  size_t strL=0;

	va_list ap;
	va_start(ap, parms);

	char **path_member = new char * [parms];


	for (int ptr_no=0; ptr_no < parms; ptr_no++)
	  {
         // prevent direct altering of any environment variables by copying
        //  them to their own buffers
       char *temp =  va_arg(ap, char *);
       path_member[ptr_no] = new char [strlen (temp) + 1];
 		 strcpy(path_member[ptr_no], temp);
		 strL += strlen(path_member[ptr_no]);
		 strL++;   //add one byte for each additional '/'
	  }
         strL++;
	 va_end(ap);

	char *sbuffer = new char [strL];
        if(!sbuffer) return 0;

	size_t slash;
	char *p;

	for (ptr_no=0, strL=0; ptr_no < parms; ptr_no++)
	  {

		 slash = strlen(path_member[ptr_no]) - 1;
		 if ( path_member[ptr_no][slash] == '\\' ||
				path_member[ptr_no][slash] == '/' )
					 path_member[ptr_no][slash] = '\0';
		 if(ptr_no > 0 && path_member[ptr_no][0] == '\\'
			 || path_member[ptr_no][0] =='/')
					p = &path_member[ptr_no][1];
			else p = &path_member[ptr_no][0];

		 if(ptr_no == 0 || path_member[ptr_no][0] == ':')
			 strL += sprintf(sbuffer + strL, "%s",p);
		 else
			strL += sprintf(sbuffer + strL, "/%s", p);

	  }

  return sbuffer;
}




 // example of table

char *column1 = "row_2, col_1<br>Second Line of col_1, row_2";
char *column2 = "row_2 col_2";

void make_table()
{
			  // Construct table at top of function, with format string.
			  //
			  // When creating a table inside a function with other elements,
			  // the TABLE constructor should not be called until the
			  // point in your code at which the table is to be output,
			  // ie. don't declare a table object at the top of a function
			  // unless the function is dedicated to the table or the table
			  // is the first html element to be output from that function .
			  //
 TABLE table("cellspacing = 0 cellpadding = 0 border = 1");

	 // output elements not specifically supported in Table Class,
	 // table headers and caption
 cout << "<caption><b>This is the overall Table Caption</b></caption>";
 cout << "<TH> This is a table example with table header</th>\n";
 cout << "<TH> table header 2</th>\n";

 // set format string for <TR> tag:  remains in effect until re-set
 table.format_row("VALIGN = TOP");
  //output a table row with two columns
 table.row_out(2,
  "row_1, col_1<br>Second Line of col_1, row_1",
  "row_1 col_2");

 table.format_row("VALIGN = bottom");  //reset <TR> format string
 table.row_out(2,column1, column2);


 //  table.ctable();
		//
	  // If the function in which the table is created is dedicated to the
	  // table, there is no need to close the table, ie. </TABLE>,
	  // since this is done in the destructor when the Table class
	  // goes out of scope at the terminaton of the function.
	  //
	  // If the table is created in a function which has other elements,
	  // then ctable() should be called to close the table when the table
	  // is complete:  duplicate closing will not occur in the destructor.
}

void mtable2()
{
         TABLE t("BORDER= 2");
              t.otag("TR");
              t.otag("TD rowspan = 2"); cout << "item 1";  t.ctag("TD");
              t.otag("TD");  cout << "item 2";  t.ctag("TD");
              t.otag("TD");  cout << "item 3";  t.ctag("TD");
              t.ctag("TR");
              t.row_out(2, "item 4", "item 5");

 }

 // example of nested lists
void makelist()
 {
	DLIST dlist;   // construct definitions type list, output: <DL>

	  // print DT element (term/item to be defined) in bold
	dlist.otag(_B);   dlist.DT("Item 1"); 	dlist.ctag(_B);

	dlist.otag("DD"); //print DD tag, then create numbered list for defs
	OLIST olist;
	 olist.item_out("First definition of item 1");
	 olist.item_out("Second definition of item 1");
	 olist.clist();   // close ordered list </OL>

		  //print second item in bold
	dlist.otag(_B);  dlist.DT("Item 2");     dlist.ctag(_B);
		dlist.item_out("Defining item 2");  // define item 2, using <DD>

 }

